#pragma once

// pass 0 to arg1 and arg4
typedef void * (* _Fallout_DynamicCast)(void * srcObj, UInt32 arg1, const void * fromType, const void * toType, UInt32 arg4);
extern const _Fallout_DynamicCast Fallout_DynamicCast;

#define DYNAMIC_CAST(obj, from, to) ( ## to *) Fallout_DynamicCast((void*)(obj), 0, RTTI_ ## from, RTTI_ ## to, 0)

extern const void * RTTI_TESIcon;
extern const void * RTTI_AlchemyItem;
extern const void * RTTI_TESFullName;
extern const void * RTTI_MagicItem;
extern const void * RTTI_MagicItemObject;
extern const void * RTTI_Setting;
extern const void * RTTI_GameSettingCollection;
extern const void * RTTI_EffectItemList;
extern const void * RTTI_EffectSetting;
extern const void * RTTI_EnchantmentItem;
extern const void * RTTI_MagicItemForm;
extern const void * RTTI_IngredientItem;
extern const void * RTTI_SpellItem;
extern const void * RTTI_BSExtraData;
extern const void * RTTI_ExtraRegionList;
extern const void * RTTI_ExtraCellMusicType;
extern const void * RTTI_ExtraCellAcousticSpace;
extern const void * RTTI_ExtraCellClimate;
extern const void * RTTI_ExtraCellImageSpace;
extern const void * RTTI_ExtraCellWaterType;
extern const void * RTTI_ExtraProcessMiddleLow;
extern const void * RTTI_ExtraSeenData;
extern const void * RTTI_ExtraNorthRotation;
extern const void * RTTI_ExtraDetachTime;
extern const void * RTTI_ExtraCell3D;
extern const void * RTTI_ExtraHavok;
extern const void * RTTI_ExtraCellCanopyShadowMask;
extern const void * RTTI_ExtraLock;
extern const void * RTTI_ExtraOpenCloseActivateRef;
extern const void * RTTI_ExtraTeleport;
extern const void * RTTI_ExtraOwnership;
extern const void * RTTI_ExtraGlobal;
extern const void * RTTI_ExtraRank;
extern const void * RTTI_ExtraCount;
extern const void * RTTI_ExtraHealth;
extern const void * RTTI_ExtraHealthPerc;
extern const void * RTTI_ExtraUses;
extern const void * RTTI_ExtraTimeLeft;
extern const void * RTTI_ExtraCharge;
extern const void * RTTI_ExtraScript;
extern const void * RTTI_ExtraScale;
extern const void * RTTI_ExtraHotKey;
extern const void * RTTI_ExtraReferencePointer;
extern const void * RTTI_ExtraTresPassPackage;
extern const void * RTTI_ExtraLeveledItem;
extern const void * RTTI_ExtraPoison;
extern const void * RTTI_ExtraHeadingTarget;
extern const void * RTTI_ExtraHasNoRumors;
extern const void * RTTI_ExtraObjectHealth;
extern const void * RTTI_ExtraTerminalState;
extern const void * RTTI_ExtraNavMeshPortal;
extern const void * RTTI_ExtraModelSwap;
extern const void * RTTI_ExtraRadius;
extern const void * RTTI_ExtraRadiation;
extern const void * RTTI_ExtraAmmo;
extern const void * RTTI_ExtraRadioData;
extern const void * RTTI_ExtraCombatStyle;
extern const void * RTTI_ExtraPrimitive;
extern const void * RTTI_ExtraPatrolRefData;
extern const void * RTTI_ExtraOcclusionPlaneRefData;
extern const void * RTTI_ExtraPortalRefData;
extern const void * RTTI_ExtraRoomRefData;
extern const void * RTTI_ExtraPackageData;
extern const void * RTTI_ExtraCollisionData;
extern const void * RTTI_BaseExtraList;
extern const void * RTTI_ExtraActorCause;
extern const void * RTTI_ExtraDataList;
extern const void * RTTI_ExtraReflectedRefs;
extern const void * RTTI_ExtraReflectorRefs;
extern const void * RTTI_ExtraWaterLightRefs;
extern const void * RTTI_ExtraLitWaterRefs;
extern const void * RTTI_ExtraEditorID;
extern const void * RTTI_ExtraAnim;
extern const void * RTTI_ExtraStartingWorldOrCell;
extern const void * RTTI_ExtraLight;
extern const void * RTTI_ExtraLeveledCreature;
extern const void * RTTI_ExtraMapMarker;
extern const void * RTTI_ExtraAction;
extern const void * RTTI_ExtraContainerChanges;
extern const void * RTTI_ExtraOriginalReference;
extern const void * RTTI_ExtraGhost;
extern const void * RTTI_ExtraWorn;
extern const void * RTTI_ExtraWornLeft;
extern const void * RTTI_ExtraCannotWear;
extern const void * RTTI_ExtraInfoGeneralTopic;
extern const void * RTTI_ExtraSeed;
extern const void * RTTI_ExtraPackageStartLocation;
extern const void * RTTI_ExtraPackage;
extern const void * RTTI_ExtraPersistentCell;
extern const void * RTTI_ExtraRagDollData;
extern const void * RTTI_ExtraEncounterZone;
extern const void * RTTI_ExtraUsedMarkers;
extern const void * RTTI_ExtraReservedMarkers;
extern const void * RTTI_ExtraDistantData;
extern const void * RTTI_ExtraEnableStateParent;
extern const void * RTTI_ExtraRandomTeleportMarker;
extern const void * RTTI_ExtraLinkedRef;
extern const void * RTTI_ExtraAshPileRef;
extern const void * RTTI_ExtraMerchantContainer;
extern const void * RTTI_ExtraLevCreaModifier;
extern const void * RTTI_ExtraLastFinishedSequence;
extern const void * RTTI_ExtraXTarget;
extern const void * RTTI_ExtraEmittanceSource;
extern const void * RTTI_ExtraMultiBoundRef;
extern const void * RTTI_ExtraMultiBoundData;
extern const void * RTTI_ExtraItemDropper;
extern const void * RTTI_ExtraSavedAnimation;
extern const void * RTTI_ExtraSavedHavokData;
extern const void * RTTI_ExtraRefractionProperty;
extern const void * RTTI_ExtraEditorRefMoveData;
extern const void * RTTI_ExtraSound;
extern const void * RTTI_ExtraCreatureAwakeSound;
extern const void * RTTI_ExtraCreatureMovementSound;
extern const void * RTTI_ExtraWeaponIdleSound;
extern const void * RTTI_ExtraWeaponAttackSound;
extern const void * RTTI_ExtraActivateLoopSound;
extern const void * RTTI_ExtraTalkingActor;
extern const void * RTTI_ExtraSayToTopicInfo;
extern const void * RTTI_ExtraIgnoredBySandbox;
extern const void * RTTI_ExtraPatrolRefInUseData;
extern const void * RTTI_ExtraStartingPosition;
extern const void * RTTI_ExtraFollower;
extern const void * RTTI_ExtraPlayerCrimeList;
extern const void * RTTI_ExtraRunOncePacks;
extern const void * RTTI_ExtraActivateRefChildren;
extern const void * RTTI_ExtraActivateRef;
extern const void * RTTI_ExtraDecalRefs;
extern const void * RTTI_ExtraMultiBound;
extern const void * RTTI_ExtraOcclusionPlane;
extern const void * RTTI_ExtraPortal;
extern const void * RTTI_ExtraRoom;
extern const void * RTTI_ExtraFactionChanges;
extern const void * RTTI_ExtraSayTopicInfoOnceADay;
extern const void * RTTI_ExtraFollowerSwimBreadcrumbs;
extern const void * RTTI_ExtraEnableStateChildren;
extern const void * RTTI_ExtraLinkedRefChildren;
extern const void * RTTI_ExtraDroppedItemList;
extern const void * RTTI_ExtraDismemberedLimbs;
extern const void * RTTI_ExtraGuardedRefData;
extern const void * RTTI_ExtraFriendHits;
extern const void * RTTI_ExtraWaterZoneMap;
extern const void * RTTI_NiAlphaProperty;
extern const void * RTTI_InterfacedClass;
extern const void * RTTI_NiRefObject;
extern const void * RTTI_QueuedReplacementKFList;
extern const void * RTTI_QueuedMagicItem;
extern const void * RTTI_BackgroundCloneThread;
extern const void * RTTI_IOTask;
extern const void * RTTI_AttachDistant3DTask;
extern const void * RTTI_BSStream;
extern const void * RTTI_LoadedFile;
extern const void * RTTI_QueuedTexture;
extern const void * RTTI_QueuedModel;
extern const void * RTTI_QueuedTreeBillboard;
extern const void * RTTI_QueuedTreeModel;
extern const void * RTTI_QueuedKF;
extern const void * RTTI_QueuedAnimIdle;
extern const void * RTTI_QueuedReplacementKF;
extern const void * RTTI_QueuedHead;
extern const void * RTTI_QueuedFileLoad;
extern const void * RTTI_QueuedFaceGenFile;
extern const void * RTTI_QueuedReference;
extern const void * RTTI_QueuedTree;
extern const void * RTTI_QueuedCharacter;
extern const void * RTTI_QueuedCreature;
extern const void * RTTI_QueuedPlayer;
extern const void * RTTI_QueuedHelmet;
extern const void * RTTI_INISettingCollection;
extern const void * RTTI_BSTempNodeManager;
extern const void * RTTI_BSTempNode;
extern const void * RTTI_TES;
extern const void * RTTI_RendererSettingCollection;
extern const void * RTTI_BGSAmmoForm;
extern const void * RTTI_BGSBipedModelList;
extern const void * RTTI_BGSClipRoundsForm;
extern const void * RTTI_BGSDestructibleObjectForm;
extern const void * RTTI_BGSEquipType;
extern const void * RTTI_BGSIdleCollection;
extern const void * RTTI_BGSMessageIcon;
extern const void * RTTI_BGSPickupPutdownSounds;
extern const void * RTTI_BGSRepairItemList;
extern const void * RTTI_BGSTouchSpellForm;
extern const void * RTTI_TESActorBaseData;
extern const void * RTTI_TESAIForm;
extern const void * RTTI_TESAnimation;
extern const void * RTTI_TESAttackDamageForm;
extern const void * RTTI_TESAttributes;
extern const void * RTTI_TESModelRDT;
extern const void * RTTI_TESBipedModelForm;
extern const void * RTTI_TESContainer;
extern const void * RTTI_TESDescription;
extern const void * RTTI_TESEnchantableForm;
extern const void * RTTI_TESForm;
extern const void * RTTI_TESHealthForm;
extern const void * RTTI_TESImageSpaceModifiableForm;
extern const void * RTTI_TESLeveledList;
extern const void * RTTI_TESModel;
extern const void * RTTI_TESModelList;
extern const void * RTTI_TESModelTextureSwap;
extern const void * RTTI_TESProduceForm;
extern const void * RTTI_TESRaceForm;
extern const void * RTTI_TESReactionForm;
extern const void * RTTI_TESScriptableForm;
extern const void * RTTI_TESSpellList;
extern const void * RTTI_TESTexture;
extern const void * RTTI_TESValueForm;
extern const void * RTTI_TESWeightForm;
extern const void * RTTI_AnimSequenceBase;
extern const void * RTTI_AnimSequenceSingle;
extern const void * RTTI_BSAnimGroupSequence;
extern const void * RTTI_AnimIdle;
extern const void * RTTI_AnimSequenceMultiple;
extern const void * RTTI_NiStencilProperty;
extern const void * RTTI_hkpRayHitCollector;
extern const void * RTTI_BSCullingProcess;
extern const void * RTTI_hkpAllRayHitCollector;
extern const void * RTTI_BSOcclusionPlane;
extern const void * RTTI_BSMultiBoundSphere;
extern const void * RTTI_BSPortal;
extern const void * RTTI_BSMultiBoundAABB;
extern const void * RTTI_BSMultiBoundOBB;
extern const void * RTTI_BGSPrimitive;
extern const void * RTTI_BGSPrimitivePlane;
extern const void * RTTI_BGSPrimitiveBox;
extern const void * RTTI_BGSPrimitiveSphere;
extern const void * RTTI_BGSSceneInfo;
extern const void * RTTI_IBSAnimNoteReceiver;
extern const void * RTTI_BSAnimNoteReceiver;
extern const void * RTTI_bhkSerializable;
extern const void * RTTI_bhkAction;
extern const void * RTTI_bhkUnaryAction;
extern const void * RTTI_bhkMouseSpringAction;
extern const void * RTTI_GridArray;
extern const void * RTTI_GridCellArray;
extern const void * RTTI_INIPrefSettingCollection;
extern const void * RTTI_BSSplatterExtraData;
extern const void * RTTI_ImageSpaceEffectParam;
extern const void * RTTI_BGSDecalNode;
extern const void * RTTI_TESRegion;
extern const void * RTTI_TESRegionData;
extern const void * RTTI_TESRegionDataGrass;
extern const void * RTTI_TESRegionDataLandscape;
extern const void * RTTI_TESRegionDataManager;
extern const void * RTTI_TESRegionDataMap;
extern const void * RTTI_TESRegionDataSound;
extern const void * RTTI_TESRegionDataWeather;
extern const void * RTTI_TESRegionGrassObject;
extern const void * RTTI_TESRegionGrassObjectList;
extern const void * RTTI_TESRegionList;
extern const void * RTTI_BGSAddonNode;
extern const void * RTTI_BGSAddonNodeSoundHandleExtra;
extern const void * RTTI_BGSConstructibleObject;
extern const void * RTTI_BGSPreloadable;
extern const void * RTTI_BGSDebris;
extern const void * RTTI_BGSExplosion;
extern const void * RTTI_BGSMovableStatic;
extern const void * RTTI_BGSPlaceableWater;
extern const void * RTTI_BGSProjectile;
extern const void * RTTI_BGSStaticCollection;
extern const void * RTTI_PathingLocation;
extern const void * RTTI_BGSTalkingActivator;
extern const void * RTTI_BGSTerminal;
extern const void * RTTI_TESAmmo;
extern const void * RTTI_TESCombatStyle;
extern const void * RTTI_TESEffectShader;
extern const void * RTTI_TESFlora;
extern const void * RTTI_TESFurniture;
extern const void * RTTI_TESGrass;
extern const void * RTTI_TESKey;
extern const void * RTTI_TESLevCharacter;
extern const void * RTTI_TESLevCreature;
extern const void * RTTI_TESLevItem;
extern const void * RTTI_TESLevSpell;
extern const void * RTTI_TESObjectLIGH;
extern const void * RTTI_TESObject;
extern const void * RTTI_TESBoundObject;
extern const void * RTTI_TESBoundAnimObject;
extern const void * RTTI_TESBoundTreeObject;
extern const void * RTTI_BGSOpenCloseForm;
extern const void * RTTI_TESObjectACTI;
extern const void * RTTI_TESObjectANIO;
extern const void * RTTI_TESObjectARMA;
extern const void * RTTI_TESObjectARMO;
extern const void * RTTI_TESObjectBOOK;
extern const void * RTTI_TESObjectCLOT;
extern const void * RTTI_TESObjectCONT;
extern const void * RTTI_TESObjectDOOR;
extern const void * RTTI_TESObjectMISC;
extern const void * RTTI_TESObjectSTAT;
extern const void * RTTI_TESModelTree;
extern const void * RTTI_TESTexture1024;
extern const void * RTTI_BSTextureSet;
extern const void * RTTI_NiBillboardNode;
extern const void * RTTI_TESIconTree;
extern const void * RTTI_TESObjectTREE;
extern const void * RTTI_BSShaderTextureSet;
extern const void * RTTI_TESObjectWEAP;
extern const void * RTTI_BGSEncounterZone;
extern const void * RTTI_BGSLightingTemplate;
extern const void * RTTI_LoadedReferenceMap;
extern const void * RTTI_ExteriorCellLoaderTask;
extern const void * RTTI_ImageSpaceModifierInstance;
extern const void * RTTI_ImageSpaceModifierInstanceForm;
extern const void * RTTI_ImageSpaceModifierInstanceDOF;
extern const void * RTTI_ImageSpaceModifierInstanceRB;
extern const void * RTTI_ImageSpaceModifierInstanceDRB;
extern const void * RTTI_TESClimate;
extern const void * RTTI_TESImageSpace;
extern const void * RTTI_NiFloatData;
extern const void * RTTI_NiColorData;
extern const void * RTTI_TESImageSpaceModifier;
extern const void * RTTI_hkBaseObject;
extern const void * RTTI_hkReferencedObject;
extern const void * RTTI_TESChildCell;
extern const void * RTTI_NiBinaryExtraData;
extern const void * RTTI_TESObjectLAND;
extern const void * RTTI_NiAdditionalGeometryData;
extern const void * RTTI_BSPackedAdditionalGeometryData;
extern const void * RTTI_hkpMoppCode;
extern const void * RTTI_TESLandTexture;
extern const void * RTTI_hkpEntityListener;
extern const void * RTTI_CheckWithinMultiBoundTask;
extern const void * RTTI_TESWindListener;
extern const void * RTTI_TESObjectCELL;
extern const void * RTTI_bhkShape;
extern const void * RTTI_bhkWorldObject;
extern const void * RTTI_bhkEntity;
extern const void * RTTI_bhkPhantom;
extern const void * RTTI_ExtraAnimNoteReceiver;
extern const void * RTTI_bhkSphereRepShape;
extern const void * RTTI_bhkConvexShape;
extern const void * RTTI_bhkCollisionObject;
extern const void * RTTI_bhkShapePhantom;
extern const void * RTTI_bhkAabbPhantom;
extern const void * RTTI_bhkSimpleShapePhantom;
extern const void * RTTI_bhkSphereShape;
extern const void * RTTI_bhkWaterPhantomCallbackShape;
extern const void * RTTI_bhkAcousticSpacePhantomCallbackShape;
extern const void * RTTI_bhkRigidBody;
extern const void * RTTI_bhkBoxShape;
extern const void * RTTI_TESObjectREFR;
extern const void * RTTI_TESWaterForm;
extern const void * RTTI_TESWeather;
extern const void * RTTI_TESWorldSpace;
extern const void * RTTI_BGSAcousticSpace;
extern const void * RTTI_BGSCameraPath;
extern const void * RTTI_NiFormArray;
extern const void * RTTI_BGSCameraShot;
extern const void * RTTI_BGSDefaultObjectManager;
extern const void * RTTI_BGSImpactData;
extern const void * RTTI_BGSImpactDataSet;
extern const void * RTTI_BGSListForm;
extern const void * RTTI_BGSMenuIcon;
extern const void * RTTI_BGSMessage;
extern const void * RTTI_TESSoundFile;
extern const void * RTTI_BGSMusicType;
extern const void * RTTI_BGSRadiationStage;
extern const void * RTTI_BGSTextureSet;
extern const void * RTTI_TESGlobal;
extern const void * RTTI_TESLoadScreen;
extern const void * RTTI_Script;
extern const void * RTTI_TileRect;
extern const void * RTTI_Tile;
extern const void * RTTI_TileMenu;
extern const void * RTTI_TESSound;
extern const void * RTTI_TESModelPSA;
extern const void * RTTI_BGSBodyPart;
extern const void * RTTI_BGSBodyPartData;
extern const void * RTTI_BGSEntryPointFunctionData;
extern const void * RTTI_BGSEntryPointFunctionDataTwoValue;
extern const void * RTTI_BGSEntryPointFunctionDataLeveledList;
extern const void * RTTI_BGSEntryPointFunctionDataOneValue;
extern const void * RTTI_BGSEntryPointFunctionDataActivateChoice;
extern const void * RTTI_BGSHeadPart;
extern const void * RTTI_BGSIdleMarker;
extern const void * RTTI_BGSNote;
extern const void * RTTI_BGSPerkEntry;
extern const void * RTTI_BGSQuestPerkEntry;
extern const void * RTTI_BGSAbilityPerkEntry;
extern const void * RTTI_BGSEntryPointPerkEntry;
extern const void * RTTI_BGSPerk;
extern const void * RTTI_BGSQuestObjective;
extern const void * RTTI_BGSRagdoll;
extern const void * RTTI_BGSVoiceType;
extern const void * RTTI_Reset3DMobIterator;
extern const void * RTTI_TESAnimGroup;
extern const void * RTTI_TESClass;
extern const void * RTTI_ActorValueOwner;
extern const void * RTTI_TESActorBase;
extern const void * RTTI_TESCreature;
extern const void * RTTI_TESEyes;
extern const void * RTTI_TESFaction;
extern const void * RTTI_TESHair;
extern const void * RTTI_TESModelAnim;
extern const void * RTTI_TESIdleForm;
extern const void * RTTI_TESNPC;
extern const void * RTTI_TESQuest;
extern const void * RTTI_BGSTextureModel;
extern const void * RTTI_TESRace;
extern const void * RTTI_TESSkill;
extern const void * RTTI_TopicInfoArray;
extern const void * RTTI_TESTopic;
extern const void * RTTI_TESTopicInfo;
extern const void * RTTI_BGSAcousticSpaceListener;
extern const void * RTTI_BGSZoneTargetListener;
extern const void * RTTI_TargetEntry;
extern const void * RTTI_ZoneEntry;
extern const void * RTTI_TrapTargetEntry;
extern const void * RTTI_hkpCdPointCollector;
extern const void * RTTI_hkpAllCdPointCollector;
extern const void * RTTI_bhkBvTreeShape;
extern const void * RTTI_bhkTriSampledHeightFieldBvTreeShape;
extern const void * RTTI_CellMopp;
extern const void * RTTI_hkpCollisionListener;
extern const void * RTTI_FOCollisionListener;
extern const void * RTTI_hkpIslandActivationListener;
extern const void * RTTI_FOIslandActivationListener;
extern const void * RTTI_HavokFileStreambufReader;
extern const void * RTTI_HavokFileStreambufWriter;
extern const void * RTTI_HavokStreambufFactory;
extern const void * RTTI_HavokError;
extern const void * RTTI_LoadedAreaBound;
extern const void * RTTI_hkpClosestRayHitCollector;
extern const void * RTTI_SpecificItemCollector;
extern const void * RTTI_TESArrowTargetListener;
extern const void * RTTI_hkpPhantomListener;
extern const void * RTTI_hkpCdBodyPairCollector;
extern const void * RTTI_bhkTrapListener;
extern const void * RTTI_TESTrapListener;
extern const void * RTTI_TrapEntry;
extern const void * RTTI_hkpAllCdBodyPairCollector;
extern const void * RTTI_WaterZone;
extern const void * RTTI_WaterTargetEntry;
extern const void * RTTI_TESWaterListener;
extern const void * RTTI_BlendSettingCollection;
extern const void * RTTI_Atmosphere;
extern const void * RTTI_Clouds;
extern const void * RTTI_Moon;
extern const void * RTTI_Precipitation;
extern const void * RTTI_Sky;
extern const void * RTTI_SkyObject;
extern const void * RTTI_SkyTask;
extern const void * RTTI_Stars;
extern const void * RTTI_Sun;
extern const void * RTTI_BSFaceGenAnimationData;
extern const void * RTTI_BSFaceGenImage;
extern const void * RTTI_BSFaceGenKeyframe;
extern const void * RTTI_BSFaceGenKeyframeMultiple;
extern const void * RTTI_BSFaceGenModelMap;
extern const void * RTTI_BSFaceGenModel;
extern const void * RTTI_BSFaceGenModelExtraData;
extern const void * RTTI_BSFaceGenMorph;
extern const void * RTTI_BSFaceGenMorphDifferential;
extern const void * RTTI_BSFaceGenMorphStatistical;
extern const void * RTTI_BSFaceGenMorphDataHead;
extern const void * RTTI_BSFaceGenMorphDataHair;
extern const void * RTTI_BSFaceGenBaseMorphExtraData;
extern const void * RTTI_BSFaceGenNiNode;
extern const void * RTTI_BSTreeModel;
extern const void * RTTI_bhkPCollisionObject;
extern const void * RTTI_bhkSPCollisionObject;
extern const void * RTTI_bhkMultiSphereShape;
extern const void * RTTI_bhkTransformShape;
extern const void * RTTI_bhkCapsuleShape;
extern const void * RTTI_BSTreeNode;
extern const void * RTTI_ActorValueInfo;
extern const void * RTTI_TESPackage;
extern const void * RTTI_TESPackageData;
extern const void * RTTI_TESAmbushPackageData;
extern const void * RTTI_TESDialoguePackageData;
extern const void * RTTI_TESEatPackageData;
extern const void * RTTI_TESEscortPackageData;
extern const void * RTTI_TESFollowPackageData;
extern const void * RTTI_TESPatrolPackageData;
extern const void * RTTI_TESUseItemPackageData;
extern const void * RTTI_ActorPackageData;
extern const void * RTTI_TESUseWeaponPackageData;
extern const void * RTTI_UseWeaponActorPackageData;
extern const void * RTTI_NiTask;
extern const void * RTTI_BSTempEffect;
extern const void * RTTI_BSTempEffectDebris;
extern const void * RTTI_NiSkinInstance;
extern const void * RTTI_BSDismemberSkinInstance;
extern const void * RTTI_BSTempEffectGeometryDecal;
extern const void * RTTI_BSTempEffectParticle;
extern const void * RTTI_BSTempEffectSimpleDecal;
extern const void * RTTI_NavMesh;
extern const void * RTTI_NavMeshPOVSearch;
extern const void * RTTI_NavMeshSearch;
extern const void * RTTI_NavMeshSearchClosePoint;
extern const void * RTTI_NavMeshSearchFlee;
extern const void * RTTI_NavMeshSearchHide;
extern const void * RTTI_NavMeshSearchLOS;
extern const void * RTTI_NavMeshSearchMaxCost;
extern const void * RTTI_NavMeshSearchSLPoint;
extern const void * RTTI_PathSmootherPOVSearch;
extern const void * RTTI_NavMeshInfoMap;
extern const void * RTTI_NavMeshInfoSearch;
extern const void * RTTI_ObstacleUndoData;
extern const void * RTTI_BSTasklet;
extern const void * RTTI_hkpEntityActivationListener;
extern const void * RTTI_bhkObstacleRemovalListener;
extern const void * RTTI_bhkObstacleDeactivationListener;
extern const void * RTTI_ObstacleData;
extern const void * RTTI_ReferenceObstacleArray;
extern const void * RTTI_BSTaskletData;
extern const void * RTTI_BSWin32TaskletData;
extern const void * RTTI_ObstacleTaskData;
extern const void * RTTI_PathingCoverLocation;
extern const void * RTTI_PathingLOSGridMap;
extern const void * RTTI_PathingLOSMap;
extern const void * RTTI_PathingRequest;
extern const void * RTTI_PathingAvoidNodeArray;
extern const void * RTTI_PathingRequestClosePoint;
extern const void * RTTI_PathingRequestCover;
extern const void * RTTI_PathingRequestCoveredMove;
extern const void * RTTI_PathingRequestFlee;
extern const void * RTTI_PathingRequestHide;
extern const void * RTTI_PathingRequestLOS;
extern const void * RTTI_PathingRequestOptimalLocation;
extern const void * RTTI_PathingRequestSafeStraightLine;
extern const void * RTTI_PathingSearchRayCast;
extern const void * RTTI_PathingSolution;
extern const void * RTTI_PathingTaskData;
extern const void * RTTI_TeleportDoorSearch;
extern const void * RTTI_BGSDistantObjectBlockLoadTask;
extern const void * RTTI_BGSDistantTreeBlockLoadTask;
extern const void * RTTI_BGSTerrainChunkLoadTask;
extern const void * RTTI_FORenderedTerminal;
extern const void * RTTI_TileImage;
extern const void * RTTI_TutorialMenu;
extern const void * RTTI_QuantityMenu;
extern const void * RTTI_TextEditMenu;
extern const void * RTTI_SurgeryMenu;
extern const void * RTTI_SPECIALBookMenu;
extern const void * RTTI_StatsMenu;
extern const void * RTTI_VATSMenu;
extern const void * RTTI_BarterMenu;
extern const void * RTTI_BookMenu;
extern const void * RTTI_CharGenMenu;
extern const void * RTTI_ComputersMenu;
extern const void * RTTI_ContainerMenu;
extern const void * RTTI_CreditsMenu;
extern const void * RTTI_DialogMenu;
extern const void * RTTI_HackingMenu;
extern const void * RTTI_HUDMainMenu;
extern const void * RTTI_InventoryMenu;
extern const void * RTTI_LevelUpMenu;
extern const void * RTTI_LoadingMenuThread;
extern const void * RTTI_LoadingMenu;
extern const void * RTTI_LockPickMenu;
extern const void * RTTI_MapMenu;
extern const void * RTTI_MessageMenu;
extern const void * RTTI_PlayerNameEntryMenu;
extern const void * RTTI_FORenderedMenuRaceSex;
extern const void * RTTI_RaceSexMenu;
extern const void * RTTI_RepairMenu;
extern const void * RTTI_RepairServicesMenu;
extern const void * RTTI_SleepWaitMenu;
extern const void * RTTI_StartMenu;
extern const void * RTTI_FOPipboyManager;
extern const void * RTTI_FORenderedMenu;
extern const void * RTTI_AbsorbEffect;
extern const void * RTTI_ActiveEffect;
extern const void * RTTI_AssociatedItemEffect;
extern const void * RTTI_bhkCharacterListenerSpell;
extern const void * RTTI_bhkTelekinesisListener;
extern const void * RTTI_BoundItemEffect;
extern const void * RTTI_CalmEffect;
extern const void * RTTI_ChameleonEffect;
extern const void * RTTI_CommandCreatureEffect;
extern const void * RTTI_CommandEffect;
extern const void * RTTI_CommandHumanoidEffect;
extern const void * RTTI_ConcussionEffect;
extern const void * RTTI_CureEffect;
extern const void * RTTI_DarknessEffect;
extern const void * RTTI_DemoralizeEffect;
extern const void * RTTI_DetectLifeEffect;
extern const void * RTTI_DisintegrateArmorEffect;
extern const void * RTTI_DisintegrateWeaponEffect;
extern const void * RTTI_DispelEffect;
extern const void * RTTI_FrenzyEffect;
extern const void * RTTI_InvisibilityEffect;
extern const void * RTTI_LightEffect;
extern const void * RTTI_LockEffect;
extern const void * RTTI_MagicBallProjectile;
extern const void * RTTI_MagicBoltProjectile;
extern const void * RTTI_MagicCaster;
extern const void * RTTI_MagicFogProjectile;
extern const void * RTTI_MagicHitEffect;
extern const void * RTTI_MagicModelHitEffect;
extern const void * RTTI_MagicProjectile;
extern const void * RTTI_MagicShaderHitEffect;
extern const void * RTTI_MagicSprayProjectile;
extern const void * RTTI_MagicTarget;
extern const void * RTTI_NightEyeEffect;
extern const void * RTTI_NonActorMagicCaster;
extern const void * RTTI_NonActorMagicTarget;
extern const void * RTTI_OpenEffect;
extern const void * RTTI_ParalysisEffect;
extern const void * RTTI_ReanimateEffect;
extern const void * RTTI_ScriptEffect;
extern const void * RTTI_ShieldEffect;
extern const void * RTTI_SummonCreatureEffect;
extern const void * RTTI_SunDamageEffect;
extern const void * RTTI_TelekinesisEffect;
extern const void * RTTI_TurnUndeadEffect;
extern const void * RTTI_ValueAndConditionsEffect;
extern const void * RTTI_ValueModifierEffect;
extern const void * RTTI_VampirismEffect;
extern const void * RTTI_CBSAReader;
extern const void * RTTI_CAsyncStream;
extern const void * RTTI_CBSAStream;
extern const void * RTTI_RadioConvTask;
extern const void * RTTI_BGSReconstructFormsMap;
extern const void * RTTI_BGSReconstructCellsMap;
extern const void * RTTI_BGSReconstructCellSubBlocksMap;
extern const void * RTTI_BGSReconstructCellBlocksMap;
extern const void * RTTI_BGSReconstructWorldSpacesMap;
extern const void * RTTI_BGSReconstructFormsInFileMap;
extern const void * RTTI_BGSOffsetDataArray;
extern const void * RTTI_BGSReconstructFormsInAllFilesMap;
extern const void * RTTI_BGSSaveLoadChangesMap;
extern const void * RTTI_BGSCellNumericIDArrayMap;
extern const void * RTTI_BGSSaveLoadStatsMap;
extern const void * RTTI_SaveGameFile;
extern const void * RTTI_ChangesMap;
extern const void * RTTI_InteriorCellNewReferencesMap;
extern const void * RTTI_ExteriorCellNewReferencesMap;
extern const void * RTTI_NumericIDBufferMap;
extern const void * RTTI_BGSLoadFormBuffer;
extern const void * RTTI_BGSLoadGameBuffer;
extern const void * RTTI_BGSSaveFormBuffer;
extern const void * RTTI_BGSSaveGameBuffer;
extern const void * RTTI_BGSMoviePlayer;
extern const void * RTTI_BSFadeNodeCuller;
extern const void * RTTI_HighActorCuller;
extern const void * RTTI_RegSettingCollection;
extern const void * RTTI_IMemoryManagerFile;
extern const void * RTTI_MemoryManagerFile;
extern const void * RTTI_SceneGraph;
extern const void * RTTI_SeenData;
extern const void * RTTI_IntSeenData;
extern const void * RTTI_CachedValuesOwner;
extern const void * RTTI_Actor;
extern const void * RTTI_bhkFilteredCdBodyCollector;
extern const void * RTTI_BSLinearTaskThread;
extern const void * RTTI_AILinearTaskThread;
extern const void * RTTI_AITaskThread;
extern const void * RTTI_DetectionTaskData;
extern const void * RTTI_AnimationTaskData;
extern const void * RTTI_PackageUpdateTaskData;
extern const void * RTTI_ActorUpdateTaskData;
extern const void * RTTI_MovementTaskData;
extern const void * RTTI_ActorsScriptTaskData;
extern const void * RTTI_BaseProcess;
extern const void * RTTI_BSPlayerDistanceCheckController;
extern const void * RTTI_Character;
extern const void * RTTI_Creature;
extern const void * RTTI_HighProcess;
extern const void * RTTI_ActorPathingMessageQueue;
extern const void * RTTI_LipTask;
extern const void * RTTI_LowProcess;
extern const void * RTTI_MiddleHighProcess;
extern const void * RTTI_MiddleLowProcess;
extern const void * RTTI_MobileObject;
extern const void * RTTI_PlayerCharacter;
extern const void * RTTI_BeamProjectile;
extern const void * RTTI_CombatAction;
extern const void * RTTI_CombatActionAttackRanged;
extern const void * RTTI_CombatActionAttackRangedFromCover;
extern const void * RTTI_CombatActionAttackRangedExplosive;
extern const void * RTTI_CombatActionAttackRangedExplosiveFromCover;
extern const void * RTTI_CombatActionAttackMelee;
extern const void * RTTI_CombatActionAttackHandToHand;
extern const void * RTTI_CombatActionAttackGrenade;
extern const void * RTTI_CombatActionAttackGrenadeFlushTarget;
extern const void * RTTI_CombatActionAttackGrenadeFromCover;
extern const void * RTTI_CombatActionMove;
extern const void * RTTI_CombatActionDrawWeapon;
extern const void * RTTI_CombatActionSwitchWeapon;
extern const void * RTTI_CombatActionAvoidThreat;
extern const void * RTTI_CombatActionSearch;
extern const void * RTTI_CombatActionInvestigate;
extern const void * RTTI_CombatActionDodge;
extern const void * RTTI_CombatActionIgnoreBlockedTarget;
extern const void * RTTI_CombatActionFlee;
extern const void * RTTI_CombatActionActivateCombatItem;
extern const void * RTTI_CombatActionUseCombatItem;
extern const void * RTTI_CombatActionApproachTarget;
extern const void * RTTI_CombatActionAcquireLineOfSight;
extern const void * RTTI_CombatActionHide;
extern const void * RTTI_CombatActionMoveAndSwitchToMelee;
extern const void * RTTI_CombatActionMoveAndAttackRanged;
extern const void * RTTI_CombatActionMoveAndAttackRangedExplosive;
extern const void * RTTI_CombatActionMoveAndAttackGrenade;
extern const void * RTTI_CombatPlanner;
extern const void * RTTI_CombatController;
extern const void * RTTI_CombatCoverMap;
extern const void * RTTI_CombatGoal;
extern const void * RTTI_CombatGoalKillTarget;
extern const void * RTTI_CombatGoalFindTarget;
extern const void * RTTI_CombatGoalAvoidThreats;
extern const void * RTTI_CombatGoalFlee;
extern const void * RTTI_CombatGoalActivateCombatItem;
extern const void * RTTI_CombatGoalUseCombatItem;
extern const void * RTTI_CombatGoalFlank;
extern const void * RTTI_CombatGoalFallBack;
extern const void * RTTI_CombatGoalAmbush;
extern const void * RTTI_CombatGoalReachDestination;
extern const void * RTTI_CombatGoalAdvance;
extern const void * RTTI_CombatGoalGuard;
extern const void * RTTI_CombatGoalCluster;
extern const void * RTTI_CombatGoalHideFromTarget;
extern const void * RTTI_CombatGoalFlushTarget;
extern const void * RTTI_CombatGoalStayInCombatArea;
extern const void * RTTI_CombatGroupStrategyFlank;
extern const void * RTTI_CombatGroupStrategyFallBack;
extern const void * RTTI_CombatGroupStrategyAmbush;
extern const void * RTTI_CombatGroupStrategyAdvance;
extern const void * RTTI_CombatTargetMap;
extern const void * RTTI_CombatThreatMap;
extern const void * RTTI_bhkLiquidAction;
extern const void * RTTI_hkpFixedBufferCdPointCollector;
extern const void * RTTI_Explosion;
extern const void * RTTI_FlameProjectile;
extern const void * RTTI_GrenadeProjectile;
extern const void * RTTI_bhkConstraint;
extern const void * RTTI_bhkHingeConstraint;
extern const void * RTTI_MissileProjectile;
extern const void * RTTI_Projectile;
extern const void * RTTI_ProjectileListener;
extern const void * RTTI_CombatProcedure;
extern const void * RTTI_CombatProcedureActivateObject;
extern const void * RTTI_CombatProcedureAttackGrenade;
extern const void * RTTI_CombatProcedureAttackLow;
extern const void * RTTI_CombatProcedureAttackMelee;
extern const void * RTTI_CombatProcedureAttackRanged;
extern const void * RTTI_CombatProcedureBeInCover;
extern const void * RTTI_CombatProcedureEngageTarget;
extern const void * RTTI_CombatProcedureEvade;
extern const void * RTTI_CombatProcedureHideFromTarget;
extern const void * RTTI_CombatProcedureMove;
extern const void * RTTI_CombatProcedureSearch;
extern const void * RTTI_CombatProcedureSwitchWeapon;
extern const void * RTTI_CombatProcedureUseCombatItem;
extern const void * RTTI_ActorMover;
extern const void * RTTI_ActorPathHandler;
extern const void * RTTI_DetailedActorPathHandler;
extern const void * RTTI_PlayerMover;
extern const void * RTTI_VirtualActorPathHandler;
extern const void * RTTI_AlarmPackage;
extern const void * RTTI_DialoguePackage;
extern const void * RTTI_EscortActorPackageData;
extern const void * RTTI_FleePackage;
extern const void * RTTI_GuardActorPackageData;
extern const void * RTTI_PatrolActorPackageData;
extern const void * RTTI_SandBoxActorPackageData;
extern const void * RTTI_SearchPackage;
extern const void * RTTI_SpectatorPackage;
extern const void * RTTI_TrespassPackage;
extern const void * RTTI_CEnumPins;
extern const void * RTTI_CEnumMediaTypes;
extern const void * RTTI_CMediaSample;
extern const void * RTTI_CMemAllocator;
extern const void * RTTI_CAsyncOutputPin;
extern const void * RTTI_CAsyncReader;
extern const void * RTTI_BSSaveDataSystemUtility;
extern const void * RTTI_BSMsgDialogSystemUtility;
extern const void * RTTI_BSSystemUtility;
extern const void * RTTI_BSSystemUtilitiesStrings;
extern const void * RTTI_BSCacheDriveSystemUtility;
extern const void * RTTI_BSGameDataSystemUtility;
extern const void * RTTI_BSDiscBootSystemUtility;
extern const void * RTTI_BSSysInfoSystemUtility;
extern const void * RTTI_MoviePlayer;
extern const void * RTTI_NiBoundingVolume;
extern const void * RTTI_NiHalfSpaceBV;
extern const void * RTTI_NiUnionBV;
extern const void * RTTI_NiCapsuleBV;
extern const void * RTTI_NiBoxBV;
extern const void * RTTI_NiSphereBV;
extern const void * RTTI_NiCollisionData;
extern const void * RTTI_NiIntersector;
extern const void * RTTI_NiCapsuleSphereIntersector;
extern const void * RTTI_NiCapsuleCapsuleIntersector;
extern const void * RTTI_NiCapsuleTriIntersector;
extern const void * RTTI_NiBoxCapsuleIntersector;
extern const void * RTTI_NiBoxSphereIntersector;
extern const void * RTTI_NiSphereTriIntersector;
extern const void * RTTI_NiOBBRoot;
extern const void * RTTI_NiOBBNode;
extern const void * RTTI_NiOBBLeaf;
extern const void * RTTI_NiObjectNET;
extern const void * RTTI_NiObject;
extern const void * RTTI_NiAVObject;
extern const void * RTTI_NiRenderer;
extern const void * RTTI_NiVertexColorProperty;
extern const void * RTTI_NiZBufferProperty;
extern const void * RTTI_NiStream;
extern const void * RTTI_NiNode;
extern const void * RTTI_NiTexture;
extern const void * RTTI_NiSourceTexture;
extern const void * RTTI_NiSourceCubeMap;
extern const void * RTTI_NiGeometryData;
extern const void * RTTI_NiDynamicEffect;
extern const void * RTTI_NiCullingProcess;
extern const void * RTTI_NiTexturingProperty;
extern const void * RTTI_NiTimeController;
extern const void * RTTI_NiAVObjectPalette;
extern const void * RTTI_NiDefaultAVObjectPalette;
extern const void * RTTI_NiCamera;
extern const void * RTTI_NiTriStrips;
extern const void * RTTI_NiLight;
extern const void * RTTI_NiStringExtraData;
extern const void * RTTI_NiTriShape;
extern const void * RTTI_NiLines;
extern const void * RTTI_NiMaterialProperty;
extern const void * RTTI_NiDirectionalLight;
extern const void * RTTI_NiTriStripsData;
extern const void * RTTI_NiImageConverter;
extern const void * RTTI_NiDevImageConverter;
extern const void * RTTI_NiExtraData;
extern const void * RTTI_NiTriShapeData;
extern const void * RTTI_NiPixelData;
extern const void * RTTI_NiPointLight;
extern const void * RTTI_NiGeometryGroupManager;
extern const void * RTTI_NiRenderedTexture;
extern const void * RTTI_NiCollisionObject;
extern const void * RTTI_NiGeometry;
extern const void * RTTI_NiTriShapeDynamicData;
extern const void * RTTI_NiSkinPartition;
extern const void * RTTI_NiSkinData;
extern const void * RTTI_BSResizableTriShape;
extern const void * RTTI_BSSegmentedTriShape;
extern const void * RTTI_NiScreenElementsData;
extern const void * RTTI_NiScreenElements;
extern const void * RTTI_NiSwitchNode;
extern const void * RTTI_NiParticles;
extern const void * RTTI_NiVertWeightsExtraData;
extern const void * RTTI_NiTriBasedGeom;
extern const void * RTTI_NiLinesData;
extern const void * RTTI_NiTriBasedGeomData;
extern const void * RTTI_NiImageReader;
extern const void * RTTI_NiNIFImageReader;
extern const void * RTTI_NiPalette;
extern const void * RTTI_NiDDSReader;
extern const void * RTTI_NiTGAReader;
extern const void * RTTI_NiBMPReader;
extern const void * RTTI_Ni2DBuffer;
extern const void * RTTI_NiShader;
extern const void * RTTI_NiParticlesData;
extern const void * RTTI_NiMaterial;
extern const void * RTTI_NiSingleShaderMaterialLibrary;
extern const void * RTTI_NiMaterialLibrary;
extern const void * RTTI_NiScreenGeometry;
extern const void * RTTI_NiScreenPolygon;
extern const void * RTTI_NiScreenGeometryData;
extern const void * RTTI_NiScreenSpaceCamera;
extern const void * RTTI_NiVectorExtraData;
extern const void * RTTI_NiTriStripsDynamicData;
extern const void * RTTI_NiTextureEffect;
extern const void * RTTI_NiSwitchStringExtraData;
extern const void * RTTI_NiStringsExtraData;
extern const void * RTTI_NiSpotLight;
extern const void * RTTI_NiSpecularProperty;
extern const void * RTTI_NiSortAdjustNode;
extern const void * RTTI_NiShadeProperty;
extern const void * RTTI_NiScreenTexture;
extern const void * RTTI_NiScreenLODData;
extern const void * RTTI_NiRangeLODData;
extern const void * RTTI_NiPersistentSrcTextureRendererData;
extern const void * RTTI_NiParticleMeshesData;
extern const void * RTTI_NiParticleMeshes;
extern const void * RTTI_NiLODNode;
extern const void * RTTI_NiIntegersExtraData;
extern const void * RTTI_NiIntegerExtraData;
extern const void * RTTI_NiFogProperty;
extern const void * RTTI_NiFloatsExtraData;
extern const void * RTTI_NiFloatExtraData;
extern const void * RTTI_NiDitherProperty;
extern const void * RTTI_NiColorExtraData;
extern const void * RTTI_NiBSPNode;
extern const void * RTTI_NiBooleanExtraData;
extern const void * RTTI_NiCullingProperty;
extern const void * RTTI_NiAmbientLight;
extern const void * RTTI_NiAlphaAccumulator;
extern const void * RTTI_NiShaderConstantMap;
extern const void * RTTI_NiDepthStencilBuffer;
extern const void * RTTI_NiGlobalConstantEntry;
extern const void * RTTI_NiShaderFactory;
extern const void * RTTI_NiSingleShaderMaterial;
extern const void * RTTI_NiLODData;
extern const void * RTTI_NiAccumulator;
extern const void * RTTI_NiBackToFrontAccumulator;
extern const void * RTTI_BSCoreMessage;
extern const void * RTTI_BSThread;
extern const void * RTTI_IMemoryHeap;
extern const void * RTTI_ZeroOverheadHeap;
extern const void * RTTI_MemoryHeap;
extern const void * RTTI_AbstractHeap;
extern const void * RTTI_NiDX9Renderer;
extern const void * RTTI_NiDX9SourceTextureData;
extern const void * RTTI_NiD3DShaderDeclaration;
extern const void * RTTI_NiDX9ShaderDeclaration;
extern const void * RTTI_NiDX92DBufferData;
extern const void * RTTI_NiDX9TextureBufferData;
extern const void * RTTI_NiDX9ImplicitBufferData;
extern const void * RTTI_NiDX9ImplicitDepthStencilBufferData;
extern const void * RTTI_NiDX9AdditionalDepthStencilBufferData;
extern const void * RTTI_NiDX9TextureData;
extern const void * RTTI_NiDX9VertexBufferManager;
extern const void * RTTI_NiD3DShader;
extern const void * RTTI_NiFragmentShaderInstanceDescriptor;
extern const void * RTTI_NiDX9FragmentShader;
extern const void * RTTI_NiD3DShaderConstantMap;
extern const void * RTTI_NiD3DGPUProgramCache;
extern const void * RTTI_NiD3DPass;
extern const void * RTTI_NiGeometryBufferData;
extern const void * RTTI_NiDX9IndexBufferManager;
extern const void * RTTI_NiDX9RenderedTextureData;
extern const void * RTTI_NiDX9SourceCubeMapData;
extern const void * RTTI_NiDX9RenderedCubeMapData;
extern const void * RTTI_NiDX9DynamicTextureData;
extern const void * RTTI_NiD3DGeometryGroupManager;
extern const void * RTTI_NiDX9ErrorShader;
extern const void * RTTI_NiDX9TextureManager;
extern const void * RTTI_NiD3DShaderInterface;
extern const void * RTTI_NiDX9RenderState;
extern const void * RTTI_NiDX9PersistentSrcTextureRendererData;
extern const void * RTTI_NiD3DShaderProgramCreator;
extern const void * RTTI_NiD3DShaderProgramCreatorHLSL;
extern const void * RTTI_NiD3DShaderProgramCreatorAsm;
extern const void * RTTI_NiD3DShaderProgramCreatorObj;
extern const void * RTTI_NiShaderConstantMapEntry;
extern const void * RTTI_NiD3DPixelShader;
extern const void * RTTI_NiD3DVertexShader;
extern const void * RTTI_NiD3DHLSLPixelShader;
extern const void * RTTI_NiD3DHLSLVertexShader;
extern const void * RTTI_NiD3DShaderProgramFactory;
extern const void * RTTI_NiStaticGeometryGroup;
extern const void * RTTI_NiUnsharedGeometryGroup;
extern const void * RTTI_NiDynamicGeometryGroup;
extern const void * RTTI_NiD3DShaderFactory;
extern const void * RTTI_NiD3DRenderState;
extern const void * RTTI_NiDX9ShaderConstantManager;
extern const void * RTTI_NiD3DShaderProgram;
extern const void * RTTI_NiGeometryGroup;
extern const void * RTTI_NiD3DShaderConstantManager;
extern const void * RTTI_NiFile;
extern const void * RTTI_NiBinaryStream;
extern const void * RTTI_NiAllocator;
extern const void * RTTI_NiStandardAllocator;
extern const void * RTTI_BSNiAllocator;
extern const void * RTTI_NiSearchPath;
extern const void * RTTI_NiMemStream;
extern const void * RTTI_NiInterpController;
extern const void * RTTI_NiControllerManager;
extern const void * RTTI_NiMultiTargetTransformController;
extern const void * RTTI_NiControllerSequence;
extern const void * RTTI_NiBlendAccumTransformInterpolator;
extern const void * RTTI_NiTransformController;
extern const void * RTTI_NiBlendInterpolator;
extern const void * RTTI_NiSingleInterpController;
extern const void * RTTI_BSMultiTargetTreadTransfController;
extern const void * RTTI_NiGeomMorpherController;
extern const void * RTTI_NiFloatInterpolator;
extern const void * RTTI_NiKeyBasedInterpolator;
extern const void * RTTI_NiColorInterpolator;
extern const void * RTTI_NiPosData;
extern const void * RTTI_NiPathInterpolator;
extern const void * RTTI_NiTransformInterpolator;
extern const void * RTTI_NiBlendFloatInterpolator;
extern const void * RTTI_NiBlendTransformInterpolator;
extern const void * RTTI_NiFloatExtraDataController;
extern const void * RTTI_NiMorphData;
extern const void * RTTI_BSFrustumFOVController;
extern const void * RTTI_BSBlendTreadTransfInterpolator;
extern const void * RTTI_BSTreadTransfInterpolator;
extern const void * RTTI_BSRotAccumTransfInterpolator;
extern const void * RTTI_BSAnimNote;
extern const void * RTTI_BSLookIKNote;
extern const void * RTTI_BSGrabIKNote;
extern const void * RTTI_BSAnimNotes;
extern const void * RTTI_NiVisController;
extern const void * RTTI_NiUVData;
extern const void * RTTI_NiUVController;
extern const void * RTTI_NiTextureTransformController;
extern const void * RTTI_NiTextKeyExtraData;
extern const void * RTTI_NiStringPalette;
extern const void * RTTI_NiSequenceStreamHelper;
extern const void * RTTI_NiSequence;
extern const void * RTTI_NiRotData;
extern const void * RTTI_NiFloatController;
extern const void * RTTI_NiRollController;
extern const void * RTTI_NiQuaternionInterpolator;
extern const void * RTTI_NiPoint3Interpolator;
extern const void * RTTI_NiPathController;
extern const void * RTTI_NiMaterialColorController;
extern const void * RTTI_NiLookAtInterpolator;
extern const void * RTTI_NiLookAtController;
extern const void * RTTI_NiLightDimmerController;
extern const void * RTTI_NiLightColorController;
extern const void * RTTI_NiKeyframeManager;
extern const void * RTTI_NiTransformData;
extern const void * RTTI_NiFloatsExtraDataPoint3Controller;
extern const void * RTTI_NiFloatsExtraDataController;
extern const void * RTTI_NiFlipController;
extern const void * RTTI_NiColorExtraDataController;
extern const void * RTTI_NiBSplineTransformInterpolator;
extern const void * RTTI_NiBSplinePoint3Interpolator;
extern const void * RTTI_NiBSplineFloatInterpolator;
extern const void * RTTI_NiBSplineCompTransformInterpolator;
extern const void * RTTI_NiBSplineCompPoint3Interpolator;
extern const void * RTTI_NiBSplineCompFloatInterpolator;
extern const void * RTTI_NiBSplineCompColorInterpolator;
extern const void * RTTI_NiBSplineColorInterpolator;
extern const void * RTTI_NiBSplineData;
extern const void * RTTI_NiBSplineBasisData;
extern const void * RTTI_NiBoolTimelineInterpolator;
extern const void * RTTI_NiBoolInterpolator;
extern const void * RTTI_NiBoolData;
extern const void * RTTI_NiBoneLODController;
extern const void * RTTI_NiBlendQuaternionInterpolator;
extern const void * RTTI_NiBlendPoint3Interpolator;
extern const void * RTTI_NiBlendColorInterpolator;
extern const void * RTTI_NiBlendBoolInterpolator;
extern const void * RTTI_NiAlphaController;
extern const void * RTTI_NiGeomMorpherUpdateTask;
extern const void * RTTI_NiInterpolator;
extern const void * RTTI_NiExtraDataController;
extern const void * RTTI_NiFloatInterpController;
extern const void * RTTI_NiBoolInterpController;
extern const void * RTTI_NiPoint3InterpController;
extern const void * RTTI_NiBSplineInterpolator;
extern const void * RTTI_BSTaskletManagerCallback;
extern const void * RTTI_bhkOnStartupCallback;
extern const void * RTTI_bhkOnExitCallback;
extern const void * RTTI_hkpCollidableCollidableFilter;
extern const void * RTTI_hkpRayCollidableFilter;
extern const void * RTTI_hkpShapeCollectionFilter;
extern const void * RTTI_hkpRayShapeCollectionFilter;
extern const void * RTTI_hkpBroadPhaseCastCollector;
extern const void * RTTI_ahkpWorld;
extern const void * RTTI_bhkMemory;
extern const void * RTTI_hkpWorldRayCaster;
extern const void * RTTI_bhkCollisionFilter;
extern const void * RTTI_bhkWorld;
extern const void * RTTI_bhkNiCollisionObject;
extern const void * RTTI_hkpCharacterProxyListener;
extern const void * RTTI_bhkCharacterListener;
extern const void * RTTI_bhkRagdollShareData;
extern const void * RTTI_hkaRaycastInterface;
extern const void * RTTI_bhkRagdollController;
extern const void * RTTI_bhkCachingShapePhantom;
extern const void * RTTI_bhkCharacterProxy;
extern const void * RTTI_bhkAvoidBox;
extern const void * RTTI_bhkCollisionBox;
extern const void * RTTI_bhkShapeCollection;
extern const void * RTTI_bhkListShape;
extern const void * RTTI_hkpClosestCdPointCollector;
extern const void * RTTI_bhkCharacterStateClimbing;
extern const void * RTTI_bhkCharacterStateFlying;
extern const void * RTTI_bhkCharacterController;
extern const void * RTTI_bhkWindListener;
extern const void * RTTI_bhkStiffSpringConstraint;
extern const void * RTTI_bhkBlendCollisionObject;
extern const void * RTTI_hkThreadMemory;
extern const void * RTTI_bhkRefObject;
extern const void * RTTI_hkpMotion;
extern const void * RTTI_WeaponObject;
extern const void * RTTI_bhkLimitedHingeConstraint;
extern const void * RTTI_bhkBinaryAction;
extern const void * RTTI_bhkBlendCollisionObjectAddRotation;
extern const void * RTTI_hkpNullContactMgr;
extern const void * RTTI_hkpBroadPhaseListener;
extern const void * RTTI_hkpPhantomBroadPhaseListener;
extern const void * RTTI_hkpBroadPhaseBorderListener;
extern const void * RTTI_hkpNullContactMgrFactory;
extern const void * RTTI_hkpNullCollisionFilter;
extern const void * RTTI_hkpDefaultConvexListFilter;
extern const void * RTTI_hkpSimpleWorldRayCaster;
extern const void * RTTI_hkpWorldLinearCaster;
extern const void * RTTI_hkpWorld;
extern const void * RTTI_bhkWorldM;
extern const void * RTTI_hkDebugDisplay;
extern const void * RTTI_hkpWorldCinfo;
extern const void * RTTI_hkpKeyframedRigidMotion;
extern const void * RTTI_hkpMaxSizeMotion;
extern const void * RTTI_hkpSphereMotion;
extern const void * RTTI_hkpWorldObject;
extern const void * RTTI_hkpStabilizedSphereMotion;
extern const void * RTTI_hkpBoxMotion;
extern const void * RTTI_hkpStabilizedBoxMotion;
extern const void * RTTI_hkpFixedRigidMotion;
extern const void * RTTI_hkpThinBoxMotion;
extern const void * RTTI_hkpCharacterMotion;
extern const void * RTTI_hkpEntity;
extern const void * RTTI_hkpRigidBody;
extern const void * RTTI_hkpPhantom;
extern const void * RTTI_hkpShapePhantom;
extern const void * RTTI_hkpShapeContainer;
extern const void * RTTI_hkPackedNiTriStripsData;
extern const void * RTTI_hkPackedNiTriStripsShape;
extern const void * RTTI_hkpTriangleShape;
extern const void * RTTI_hkNiTriStripsShape;
extern const void * RTTI_bhkPackedNiTriStripsShape;
extern const void * RTTI_bhkNiTriStripsShape;
extern const void * RTTI_bhkBlendController;
extern const void * RTTI_hkpSingleShapeContainer;
extern const void * RTTI_hkpBvShape;
extern const void * RTTI_hkpBoxShape;
extern const void * RTTI_hkaRagdollRaycastInterface;
extern const void * RTTI_bhkRagdollPenetrationUtil;
extern const void * RTTI_hkpCharacterContext;
extern const void * RTTI_hkpFirstCdBodyPairCollector;
extern const void * RTTI_hkAvoidBox;
extern const void * RTTI_bhkMalleableConstraint;
extern const void * RTTI_hkpMalleableConstraintData;
extern const void * RTTI_ahkpMalleableConstraintData;
extern const void * RTTI_hkpCharacterProxy;
extern const void * RTTI_hkBSHeightFieldShape;
extern const void * RTTI_hkErrStream;
extern const void * RTTI_bhkRigidBodyT;
extern const void * RTTI_bhkWaterListener;
extern const void * RTTI_ahkpCharacterProxy;
extern const void * RTTI_hkpLimitedHingeConstraintData;
extern const void * RTTI_bhkForceController;
extern const void * RTTI_bhkOrientHingedBodyAction;
extern const void * RTTI_bhkBallAndSocketConstraint;
extern const void * RTTI_bhkRagdollConstraint;
extern const void * RTTI_bhkRagdollTemplateData;
extern const void * RTTI_bhkRagdollTemplate;
extern const void * RTTI_hkpMouseSpringAction;
extern const void * RTTI_hkMemory;
extern const void * RTTI_hkNativeFileSystem;
extern const void * RTTI_hkDummySingleton;
extern const void * RTTI_hkDefaultError;
extern const void * RTTI_hkpCharacterStateManager;
extern const void * RTTI_hkpHingeConstraintData;
extern const void * RTTI_hkDefaultBuiltinTypeRegistry;
extern const void * RTTI_hkRenamedClassNameRegistry;
extern const void * RTTI_hkpPhantomOverlapListener;
extern const void * RTTI_hkpCollisionFilter;
extern const void * RTTI_hkArrayStreamWriter;
extern const void * RTTI_hkOstream;
extern const void * RTTI_hkLoader;
extern const void * RTTI_bhkPoseArray;
extern const void * RTTI_bhkExtraData;
extern const void * RTTI_bhkSpringAction;
extern const void * RTTI_bhkMotorAction;
extern const void * RTTI_bhkDashpotAction;
extern const void * RTTI_bhkAngularDashpotAction;
extern const void * RTTI_bhkBreakableConstraint;
extern const void * RTTI_hkpBreakableConstraintData;
extern const void * RTTI_ahkpBreakableConstraintData;
extern const void * RTTI_bhkWheelConstraint;
extern const void * RTTI_bhkRagdollLimitsConstraint;
extern const void * RTTI_bhkPrismaticConstraint;
extern const void * RTTI_bhkFixedConstraint;
extern const void * RTTI_bhkGenericConstraint;
extern const void * RTTI_bhkHingeLimitsConstraint;
extern const void * RTTI_bhkBallSocketConstraintChain;
extern const void * RTTI_bhkConstraintChain;
extern const void * RTTI_bhkMoppBvTreeShape;
extern const void * RTTI_hkScaledMoppBvTreeShape;
extern const void * RTTI_bhkTriangleShape;
extern const void * RTTI_bhkPlaneShape;
extern const void * RTTI_bhkHeightFieldShape;
extern const void * RTTI_bhkExtendedMeshShapeData;
extern const void * RTTI_bhkExtendedMeshShape;
extern const void * RTTI_bhkCylinderShape;
extern const void * RTTI_bhkConvexVerticesShape;
extern const void * RTTI_bhkConvexTransformShape;
extern const void * RTTI_bhkConvexSweepShape;
extern const void * RTTI_bhkConvexListShape;
extern const void * RTTI_hkVisualDebugger;
extern const void * RTTI_hkpWorldDeletionListener;
extern const void * RTTI_hkpActionListener;
extern const void * RTTI_hkpConstraintListener;
extern const void * RTTI_hkProcessContext;
extern const void * RTTI_hkpPhysicsContext;
extern const void * RTTI_hkpRagdollConstraintData;
extern const void * RTTI_hkaFootPlacementIkSolver;
extern const void * RTTI_hkpConstraintMotor;
extern const void * RTTI_hkpLimitedForceConstraintMotor;
extern const void * RTTI_hkpPositionConstraintMotor;
extern const void * RTTI_hkaRagdollInstance;
extern const void * RTTI_hkaSkeletonMapper;
extern const void * RTTI_bhkCharacterPointCollector;
extern const void * RTTI_bhkCharacterStateProjectile;
extern const void * RTTI_bhkCharacterStateInAir;
extern const void * RTTI_bhkCharacterStateJumping;
extern const void * RTTI_bhkCharacterStateSwimming;
extern const void * RTTI_bhkCharacterStateOnGround;
extern const void * RTTI_hkCharControllerShape;
extern const void * RTTI_bhkCharControllerShape;
extern const void * RTTI_hkpSphereShape;
extern const void * RTTI_hkpAabbPhantom;
extern const void * RTTI_hkpBinaryAction;
extern const void * RTTI_hkpConstraintInstance;
extern const void * RTTI_bhkPositionConstraintMotor;
extern const void * RTTI_hkpVelocityConstraintMotor;
extern const void * RTTI_bhkVelocityConstraintMotor;
extern const void * RTTI_bhkSpringDamperConstraintMotor;
extern const void * RTTI_hkpShapeCollection;
extern const void * RTTI_hkpListShape;
extern const void * RTTI_hkpTransformShape;
extern const void * RTTI_hkpSpatialRigidBodyDeactivator;
extern const void * RTTI_hkpSimulation;
extern const void * RTTI_hkpMultiThreadedSimulation;
extern const void * RTTI_hkpNullBroadPhaseListener;
extern const void * RTTI_hkpCollisionDispatcher;
extern const void * RTTI_hkpReportContactMgr;
extern const void * RTTI_hkpSimpleContactConstraintData;
extern const void * RTTI_hkpSimpleConstraintContactMgr;
extern const void * RTTI_hkpPhysicsSystem;
extern const void * RTTI_hkpConstraintOwner;
extern const void * RTTI_hkpSimulationIsland;
extern const void * RTTI_hkpDefaultWorldMaintenanceMgr;
extern const void * RTTI_hkpBroadPhaseBorder;
extern const void * RTTI_hkpContinuousSimulation;
extern const void * RTTI_hkpNullAgent;
extern const void * RTTI_hkpEntityEntityBroadPhaseListener;
extern const void * RTTI_hkp3AxisSweep;
extern const void * RTTI_hkpSimpleShapePhantom;
extern const void * RTTI_hkaDetectRagdollPenetration;
extern const void * RTTI_hkpCapsuleShape;
extern const void * RTTI_hkDisplayGeometry;
extern const void * RTTI_hkDisplayCapsule;
extern const void * RTTI_hkpSampledHeightFieldShape;
extern const void * RTTI_hkpTriSampledHeightFieldCollection;
extern const void * RTTI_hkpTriSampledHeightFieldBvTreeShape;
extern const void * RTTI_hkBufferedStreamWriter;
extern const void * RTTI_hkpMultiSphereShape;
extern const void * RTTI_hkOrientHingedBodyAction;
extern const void * RTTI_hkpUnaryAction;
extern const void * RTTI_hkBufferedStreamReader;
extern const void * RTTI_hkStdioStreamReader;
extern const void * RTTI_hkStdioStreamWriter;
extern const void * RTTI_hkStackTracer;
extern const void * RTTI_hkSocket;
extern const void * RTTI_hkLiquidAction;
extern const void * RTTI_hkDynamicClassNameRegistry;
extern const void * RTTI_hkDefaultClassNameRegistry;
extern const void * RTTI_hkTypeInfoRegistry;
extern const void * RTTI_hkVtableClassRegistry;
extern const void * RTTI_hkStaticClassNameRegistry;
extern const void * RTTI_ValidatedClassNameRegistry;
extern const void * RTTI_hkVersionRegistry;
extern const void * RTTI_hkObjectCopier;
extern const void * RTTI_hkpSymmetricAgentFlipCollector;
extern const void * RTTI_hkpSymmetricAgentFlipCastCollector;
extern const void * RTTI_hkpSymmetricAgentFlipBodyCollector;
extern const void * RTTI_hkpBvTreeStreamAgent;
extern const void * RTTI_hkpBvTreeAgent;
extern const void * RTTI_hkpMoppAgent;
extern const void * RTTI_hkHeightFieldRayForwardingCollector;
extern const void * RTTI_hkpHeightFieldAgent;
extern const void * RTTI_hkpMapPointsToSubShapeContactMgr;
extern const void * RTTI_hkpPredGskfAgent;
extern const void * RTTI_hkpFlagCdBodyPairCollector;
extern const void * RTTI_hkpSimpleClosestContactCollector;
extern const void * RTTI_hkpConvexListAgent;
extern const void * RTTI_hkpListAgent;
extern const void * RTTI_hkpMultiRayConvexAgent;
extern const void * RTTI_hkpMultiSphereTriangleAgent;
extern const void * RTTI_hkpCapsuleTriangleAgent;
extern const void * RTTI_hkpCapsuleCapsuleAgent;
extern const void * RTTI_hkpSphereBoxAgent;
extern const void * RTTI_hkpSphereTriangleAgent;
extern const void * RTTI_hkpSphereCapsuleAgent;
extern const void * RTTI_hkpSphereSphereAgent;
extern const void * RTTI_hkpBoxBoxAgent;
extern const void * RTTI_hkpPhantomAgent;
extern const void * RTTI_hkpTransformAgent;
extern const void * RTTI_hkpShapeCollectionAgent;
extern const void * RTTI_hkpMultiSphereAgent;
extern const void * RTTI_hkpBvAgent;
extern const void * RTTI_hkpStorageSampledHeightFieldShape;
extern const void * RTTI_hkpStorageExtendedMeshShape;
extern const void * RTTI_hkpStorageMeshShape;
extern const void * RTTI_hkpPhysicsData;
extern const void * RTTI_hkXmlPackfileWriter;
extern const void * RTTI_hkBinaryPackfileWriter;
extern const void * RTTI_hkSubStreamWriter;
extern const void * RTTI_hkpPhysicsSystemWithContacts;
extern const void * RTTI_hkpCachingShapePhantom;
extern const void * RTTI_hkpSpringAction;
extern const void * RTTI_hkpMotorAction;
extern const void * RTTI_hkpDashpotAction;
extern const void * RTTI_hkpAngularDashpotAction;
extern const void * RTTI_hkpWheelConstraintData;
extern const void * RTTI_hkpStiffSpringConstraintData;
extern const void * RTTI_hkpRagdollLimitsData;
extern const void * RTTI_hkpPrismaticConstraintData;
extern const void * RTTI_hkpGenericConstraintData;
extern const void * RTTI_hkpHingeLimitsData;
extern const void * RTTI_hkpBallSocketChainData;
extern const void * RTTI_hkpBallAndSocketConstraintData;
extern const void * RTTI_hkMoppBvTreeShapeBase;
extern const void * RTTI_hkpMoppBvTreeShape;
extern const void * RTTI_hkpPlaneShape;
extern const void * RTTI_hkpExtendedMeshShape;
extern const void * RTTI_hkpCylinderShape;
extern const void * RTTI_hkDisplayCylinder;
extern const void * RTTI_hkpConvexVerticesShape;
extern const void * RTTI_hkpConvexTransformShape;
extern const void * RTTI_hkpConvexListShape;
extern const void * RTTI_hkOArchive;
extern const void * RTTI_hkProcess;
extern const void * RTTI_hkProcessHandler;
extern const void * RTTI_hkCommandRouter;
extern const void * RTTI_hkServerProcessHandler;
extern const void * RTTI_hkpWorldSnapshotViewer;
extern const void * RTTI_hkpWorldMemoryViewer;
extern const void * RTTI_hkpWorldPostSimulationListener;
extern const void * RTTI_hkpVehicleViewer;
extern const void * RTTI_hkpSweptTransformDisplayViewer;
extern const void * RTTI_hkDisplayAABB;
extern const void * RTTI_hkpSimulationIslandViewer;
extern const void * RTTI_hkpShapeDisplayViewer;
extern const void * RTTI_hkpUserShapePhantomTypeIdentifier;
extern const void * RTTI_hkpPhantomDisplayViewer;
extern const void * RTTI_hkpMousePickingViewer;
extern const void * RTTI_hkDisplayBox;
extern const void * RTTI_hkpRigidBodyInertiaViewer;
extern const void * RTTI_hkpToiContactPointViewer;
extern const void * RTTI_hkpInactiveContactPointViewer;
extern const void * RTTI_hkpActiveContactPointViewer;
extern const void * RTTI_hkpConvexRadiusViewer;
extern const void * RTTI_hkpConstraintViewer;
extern const void * RTTI_hkpRigidBodyCentreOfMassViewer;
extern const void * RTTI_hkpMidphaseViewer;
extern const void * RTTI_hkpBroadphaseViewer;
extern const void * RTTI_hkpSerializedDisplayRbTransforms;
extern const void * RTTI_hkpPoweredChainMapper;
extern const void * RTTI_hkpPairwiseCollisionFilter;
extern const void * RTTI_hkpRotationalConstraintData;
extern const void * RTTI_hkpPulleyConstraintData;
extern const void * RTTI_hkpPointToPlaneConstraintData;
extern const void * RTTI_hkpSimpleMeshShape;
extern const void * RTTI_hkpMultiRayShape;
extern const void * RTTI_hkpConvexPieceStreamData;
extern const void * RTTI_hkpSerializedDisplayMarkerList;
extern const void * RTTI_hkpSerializedDisplayMarker;
extern const void * RTTI_hkpReorientAction;
extern const void * RTTI_hkpGroupCollisionFilter;
extern const void * RTTI_hkpDisableEntityCollisionFilter;
extern const void * RTTI_hkpConstrainedSystemFilter;
extern const void * RTTI_hkpSpringDamperConstraintMotor;
extern const void * RTTI_hkpPointToPathConstraintData;
extern const void * RTTI_hkpLinearParametricCurve;
extern const void * RTTI_hkpFakeRigidBodyDeactivator;
extern const void * RTTI_hkpConstraintChainInstanceAction;
extern const void * RTTI_hkpConstraintChainInstance;
extern const void * RTTI_hkpCallbackConstraintMotor;
extern const void * RTTI_hkpMoppModifier;
extern const void * RTTI_hkpRemoveTerminalsMoppModifier;
extern const void * RTTI_hkpGroupFilter;
extern const void * RTTI_hkpFastMeshShape;
extern const void * RTTI_hkpConvexVerticesConnectivity;
extern const void * RTTI_hkpConvexTranslateShape;
extern const void * RTTI_hkpConvexPieceMeshShape;
extern const void * RTTI_hkpCollisionFilterList;
extern const void * RTTI_hkStatisticsCollectorClassListener;
extern const void * RTTI_hkpDeferredConstraintOwner;
extern const void * RTTI_hkpBroadPhase;
extern const void * RTTI_hkTraceStream;
extern const void * RTTI_hkpDefaultToiResourceMgr;
extern const void * RTTI_hkBsdSocket;
extern const void * RTTI_hkCrc32StreamWriter;
extern const void * RTTI_hkBindingClassNameRegistry;
extern const void * RTTI_hkpGskBaseAgent;
extern const void * RTTI_hkpGskfAgent;
extern const void * RTTI_hkpMeshShape;
extern const void * RTTI_hkPackfileObjectUpdateTracker;
extern const void * RTTI_hkBinaryPackfileReader;
extern const void * RTTI_hkXmlPackfileReader;
extern const void * RTTI_hkXmlPackfileUpdateTracker;
extern const void * RTTI_hkPackfileReader;
extern const void * RTTI_hkIstream;
extern const void * RTTI_hkPackfileWriter;
extern const void * RTTI_hkXmlObjectWriter;
extern const void * RTTI_hkPlatformObjectWriter;
extern const void * RTTI_hkpMoppCostFunction;
extern const void * RTTI_hkpMoppShapeMediator;
extern const void * RTTI_hkpMoppCachedShapeMediator;
extern const void * RTTI_hkWindowsSystemClock;
extern const void * RTTI_hkIArchive;
extern const void * RTTI_hkProcessFactory;
extern const void * RTTI_hkDebugDisplayHandler;
extern const void * RTTI_hkServerDebugDisplayHandler;
extern const void * RTTI_hkDisplaySerializeOStream;
extern const void * RTTI_hkDisplaySerializeIStream;
extern const void * RTTI_hkInspectProcess;
extern const void * RTTI_hkStatisticsProcess;
extern const void * RTTI_hkDebugDisplayProcess;
extern const void * RTTI_hkpPhysicsContextWorldListener;
extern const void * RTTI_hkpWorldViewerBase;
extern const void * RTTI_hkStatisticsCollector;
extern const void * RTTI_hkStreamStatisticsCollector;
extern const void * RTTI_hkpShapeDisplayBuilder;
extern const void * RTTI_hkpUserShapeDisplayBuilder;
extern const void * RTTI_hkDisplayConvex;
extern const void * RTTI_hkpContactPointViewer;
extern const void * RTTI_hkpConvexRadiusBuilder;
extern const void * RTTI_hkpUserConvexRadiusBuilder;
extern const void * RTTI_hkDisplaySemiCircle;
extern const void * RTTI_hkDisplayPlane;
extern const void * RTTI_hkDisplayCone;
extern const void * RTTI_hkpStiffSpringChainData;
extern const void * RTTI_hkpPoweredChainData;
extern const void * RTTI_hkChainedClassNameRegistry;
extern const void * RTTI_hkPackfileData;
extern const void * RTTI_hkXmlParser;
extern const void * RTTI_hkLineNumberStreamReader;
extern const void * RTTI_hkXmlObjectReader;
extern const void * RTTI_hkMemoryStreamReader;
extern const void * RTTI_hkOffsetOnlyStreamWriter;
extern const void * RTTI_hkpMoppCodeGenerator;
extern const void * RTTI_hkpMoppDefaultAssembler;
extern const void * RTTI_hkpMoppDefaultSplitter;
extern const void * RTTI_hkDisplaySphere;
extern const void * RTTI_hkpConvexPieceShape;
extern const void * RTTI_BSMultiBound;
extern const void * RTTI_BSMultiBoundRoom;
extern const void * RTTI_IOManager;
extern const void * RTTI_QueuedFile;
extern const void * RTTI_QueuedFileEntry;
extern const void * RTTI_QueuedChildren;
extern const void * RTTI_QueuedParents;
extern const void * RTTI_MessageHandler;
extern const void * RTTI_BSXFlags;
extern const void * RTTI_BSTaskThread;
extern const void * RTTI_BSReference;
extern const void * RTTI_BSNodeReferences;
extern const void * RTTI_BSValueNode;
extern const void * RTTI_BSRangeNode;
extern const void * RTTI_BSParallelTaskThread;
extern const void * RTTI_BSMultiBoundNode;
extern const void * RTTI_BSWindModifier;
extern const void * RTTI_BSBlastNode;
extern const void * RTTI_BSDebrisNode;
extern const void * RTTI_BSDamageStage;
extern const void * RTTI_BSMultiBoundShape;
extern const void * RTTI_BSPortalSharedNode;
extern const void * RTTI_BSParticleSystemManager;
extern const void * RTTI_BSSceneGraph;
extern const void * RTTI_NiBSBoneLODController;
extern const void * RTTI_BSFurnitureMarker;
extern const void * RTTI_BSBound;
extern const void * RTTI_BSPortalGraph;
extern const void * RTTI_BSPSysMultiTargetEmitterCtlr;
extern const void * RTTI_BSScissorTriShape;
extern const void * RTTI_BSNiNode;
extern const void * RTTI_BSPSysStripUpdateModifier;
extern const void * RTTI_BSPSysSimpleColorModifier;
extern const void * RTTI_BSMultiBoundCapsule;
extern const void * RTTI_BSMasterParticleSystem;
extern const void * RTTI_BSWArray;
extern const void * RTTI_BSPSysArrayEmitter;
extern const void * RTTI_BSParentVelocityModifier;
extern const void * RTTI_BSDecalPlacementVectorExtraData;
extern const void * RTTI_BSTextureData;
extern const void * RTTI_NiParticleSystem;
extern const void * RTTI_NiPSysEmitterCtlr;
extern const void * RTTI_NiPSysMeshEmitter;
extern const void * RTTI_NiPSysCylinderEmitter;
extern const void * RTTI_NiPSysSphereEmitter;
extern const void * RTTI_NiPSysBoxEmitter;
extern const void * RTTI_NiPSysMeshUpdateModifier;
extern const void * RTTI_NiPSysRotationModifier;
extern const void * RTTI_NiMeshParticleSystem;
extern const void * RTTI_NiPSysEmitter;
extern const void * RTTI_NiPSysGravityModifier;
extern const void * RTTI_NiPSysSpawnModifier;
extern const void * RTTI_NiPSysData;
extern const void * RTTI_BSStripParticleSystem;
extern const void * RTTI_BSStripPSysData;
extern const void * RTTI_NiPSysModifier;
extern const void * RTTI_NiPSysVolumeEmitter;
extern const void * RTTI_NiPSysModifierCtlr;
extern const void * RTTI_NiPSysUpdateTask;
extern const void * RTTI_NiPSysVortexFieldModifier;
extern const void * RTTI_NiPSysUpdateCtlr;
extern const void * RTTI_NiPSysTurbulenceFieldModifier;
extern const void * RTTI_NiPSysSphericalCollider;
extern const void * RTTI_NiPSysResetOnLoopCtlr;
extern const void * RTTI_NiPSysRadialFieldModifier;
extern const void * RTTI_NiPSysPositionModifier;
extern const void * RTTI_NiPSysPlanarCollider;
extern const void * RTTI_NiPSysModifierActiveCtlr;
extern const void * RTTI_NiPSysInitialRotSpeedVarCtlr;
extern const void * RTTI_NiPSysInitialRotSpeedCtlr;
extern const void * RTTI_NiPSysInitialRotAngleVarCtlr;
extern const void * RTTI_NiPSysInitialRotAngleCtlr;
extern const void * RTTI_NiPSysGrowFadeModifier;
extern const void * RTTI_NiPSysGravityStrengthCtlr;
extern const void * RTTI_NiPSysGravityFieldModifier;
extern const void * RTTI_NiPSysFieldMaxDistanceCtlr;
extern const void * RTTI_NiPSysFieldMagnitudeCtlr;
extern const void * RTTI_NiPSysFieldAttenuationCtlr;
extern const void * RTTI_NiPSysEmitterSpeedCtlr;
extern const void * RTTI_NiPSysEmitterPlanarAngleVarCtlr;
extern const void * RTTI_NiPSysEmitterPlanarAngleCtlr;
extern const void * RTTI_NiPSysEmitterLifeSpanCtlr;
extern const void * RTTI_NiPSysEmitterInitialRadiusCtlr;
extern const void * RTTI_NiPSysEmitterDeclinationVarCtlr;
extern const void * RTTI_NiPSysEmitterDeclinationCtlr;
extern const void * RTTI_NiPSysEmitterCtlrData;
extern const void * RTTI_NiPSysDragModifier;
extern const void * RTTI_NiPSysDragFieldModifier;
extern const void * RTTI_NiPSysColorModifier;
extern const void * RTTI_NiPSysColliderManager;
extern const void * RTTI_NiPSysBoundUpdateModifier;
extern const void * RTTI_NiPSysBombModifier;
extern const void * RTTI_NiPSysAgeDeathModifier;
extern const void * RTTI_NiPSysAirFieldSpreadCtlr;
extern const void * RTTI_NiPSysAirFieldModifier;
extern const void * RTTI_NiPSysAirFieldInheritVelocityCtlr;
extern const void * RTTI_NiPSysAirFieldAirFrictionCtlr;
extern const void * RTTI_NiMeshPSysData;
extern const void * RTTI_NiPSysFieldModifier;
extern const void * RTTI_NiPSysCollider;
extern const void * RTTI_NiPSysModifierBoolCtlr;
extern const void * RTTI_NiPSysModifierFloatCtlr;
extern const void * RTTI_IdvFileError;
extern const void * RTTI_CIdvCamera;
extern const void * RTTI_CTreeEngine;
extern const void * RTTI_Random;
extern const void * RTTI_Uniform;
extern const void * RTTI_CBillboardLeaf;
extern const void * RTTI_PosGen;
extern const void * RTTI_Normal;
extern const void * RTTI_Archive;
extern const void * RTTI_ArchiveFile;
extern const void * RTTI_CompressedArchiveFile;
extern const void * RTTI_BSFile;
extern const void * RTTI_BSSearchPath;
extern const void * RTTI_BSFileCache;
extern const void * RTTI_BSWin32FileCache;
extern const void * RTTI_BSTaskletManager;
extern const void * RTTI_BSWin32TaskletManager;
extern const void * RTTI_BSTaskletGroupData;
extern const void * RTTI_BSWin32TaskletGroupData;
extern const void * RTTI_BSAudio;
extern const void * RTTI_AudioLoadTask;
extern const void * RTTI_BSAudioManagerThread;
extern const void * RTTI_BSAudioManager;
extern const void * RTTI_BSGameSound;
extern const void * RTTI_BSWin32Audio;
extern const void * RTTI_BSAudioListener;
extern const void * RTTI_BSWin32AudioListener;
extern const void * RTTI_BSWin32GameSound;
extern const void * RTTI_FutBinaryFileC;
extern const void * RTTI_BSFaceGenBinaryFile;
extern const void * RTTI_TileText;
extern const void * RTTI_Tile3D;
extern const void * RTTI_DebugTextExtraData;
extern const void * RTTI_DebugText;
extern const void * RTTI_Menu;
extern const void * RTTI_type_info;
extern const void * RTTI_NiRenderedCubeMap;
extern const void * RTTI_NiRenderTargetGroup;
extern const void * RTTI_NiShaderDeclaration;
extern const void * RTTI_NiGPUProgramCache;
extern const void * RTTI_NiSCMExtraData;
extern const void * RTTI_NiMaterialResource;
extern const void * RTTI_NiD3DDefaultShader;
