#ifndef __FOSE_VERSION_H__
#define __FOSE_VERSION_H__

// these have to be macros so they can be used in the .rc
#define FOSE_VERSION_INTEGER		1
#define FOSE_VERSION_INTEGER_MINOR	2
#define FOSE_VERSION_INTEGER_BETA	0
#define FOSE_VERSION_VERSTRING		"0, 1, 2, 0"
#define FOSE_VERSION_PADDEDSTRING	"0001"

// build numbers do not appear to follow the same format as with oblivion
#define MAKE_FALLOUT_VERSION_EX(major, minor, build, sub)	(((major & 0xFF) << 24) | ((minor & 0xFF) << 16) | ((build & 0xFFF) << 4) | (sub & 0xF))
#define MAKE_FALLOUT_VERSION(major, minor, build)			MAKE_FALLOUT_VERSION_EX(major, minor, build, 0)

#define FALLOUT_VERSION_1_0		MAKE_FALLOUT_VERSION(1, 0, 12)			// 0x010000C0
#define FALLOUT_VERSION_1_0_15	MAKE_FALLOUT_VERSION(1, 0, 15)			// 0x010000F0
#define FALLOUT_VERSION_1_1_35	MAKE_FALLOUT_VERSION(1, 1, 35)			// 0x01010230
#define FALLOUT_VERSION_1_4_6	MAKE_FALLOUT_VERSION(1, 4, 6)			// 0x01040060
#define FALLOUT_VERSION_1_4_6b	MAKE_FALLOUT_VERSION_EX(1, 4, 6, 1)		// 0x01040061
#define FALLOUT_VERSION_1_5_22	MAKE_FALLOUT_VERSION(1, 5, 22)			// 0x01050160
#define FALLOUT_VERSION_1_6		MAKE_FALLOUT_VERSION(1, 6, 3)			// 0x01060030
#define FALLOUT_VERSION_1_7		MAKE_FALLOUT_VERSION(1, 7, 3)			// 0x01070030

#define CS_VERSION_1_1_36		MAKE_FALLOUT_VERSION(1, 1, 36)			// 0x01010240
#define CS_VERSION_1_5_19		MAKE_FALLOUT_VERSION(1, 5, 19)			// 0x01050130

#define PACKED_FOSE_VERSION		MAKE_FALLOUT_VERSION(FOSE_VERSION_INTEGER, FOSE_VERSION_INTEGER_MINOR, FOSE_VERSION_INTEGER_BETA)

#endif /* __FOSE_VERSION_H__ */
